import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
export declare const startTemplate: string;
export declare const endTemplate: string;
export interface IBespoke {
    readonly name: string;
}
export declare class Bespoke extends NamedRenderer {
    private readonly props;
    static new(props: IBespoke): Bespoke;
    private constructor();
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
