import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
export interface IEnum {
    readonly name: string;
    readonly values: {
        [index: string]: string | number;
    };
}
export declare class Enum extends NamedRenderer {
    private readonly props;
    private readonly exported;
    static newExported(props: IEnum): Enum;
    static newInternal(props: IEnum): Enum;
    private constructor();
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
