"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Enum = (function (_super) {
    __extends(Enum, _super);
    function Enum(props, exported) {
        var _this = _super.call(this) || this;
        _this.props = props;
        _this.exported = exported;
        return _this;
    }
    Enum.newExported = function (props) {
        return new Enum(props, true);
    };
    Enum.newInternal = function (props) {
        return new Enum(props, false);
    };
    Enum.prototype.render = function (builder) {
        builder.withIdentifiers(this.props.name);
        if (this.exported) {
            builder.add("export ");
        }
        builder
            .addThenNewline("enum " + this.props.name + " {")
            .indent();
        for (var _i = 0, _a = Object.keys(this.props.values); _i < _a.length; _i++) {
            var key = _a[_i];
            builder.add(key + " = ");
            if (typeof this.props.values[key] === "string") {
                builder.addThenNewline("\"" + this.props.values[key] + "\",");
            }
            else {
                builder.addThenNewline(this.props.values[key] + ",");
            }
        }
        builder
            .unindent()
            .addThenNewline("}");
    };
    Enum.prototype.verify = function (builder) {
    };
    return Enum;
}(renderer_1.NamedRenderer));
exports.Enum = Enum;
