import { Builder } from "./builder";
import { NamedRenderer, TRenderer } from "./renderer";
export interface IModule {
    readonly content: TRenderer[];
    readonly destination: string;
}
export declare class Module extends NamedRenderer {
    private readonly props;
    static new(props: IModule): Module;
    private static getHash;
    private static renderImports;
    private static renderImportSection;
    private static renderNonImports;
    private constructor();
    destination(): string;
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
    private verifyUniqueBespoke;
    private verifyUniqueIdentifiers;
}
