import { Builder } from "./builder";
import { NamedRenderer, TRenderer } from "./renderer";
export interface INamespace {
    readonly content: TRenderer[];
    readonly name: string;
}
export declare class Namespace extends NamedRenderer {
    private readonly props;
    private readonly exported;
    static newExported(props: INamespace): Namespace;
    static newInternal(props: INamespace): Namespace;
    private constructor();
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
