"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Namespace = (function (_super) {
    __extends(Namespace, _super);
    function Namespace(props, exported) {
        var _this = _super.call(this) || this;
        _this.props = props;
        _this.exported = exported;
        return _this;
    }
    Namespace.newExported = function (props) {
        return new Namespace(props, true);
    };
    Namespace.newInternal = function (props) {
        return new Namespace(props, false);
    };
    Namespace.prototype.render = function (builder) {
        builder.withIdentifiers(this.props.name);
        if (this.exported) {
            builder.add("export ");
        }
        builder
            .addThenNewline("namespace " + this.props.name + " {")
            .indent();
        this.props.content
            .forEach(function (content) {
            builder.ensureOnNewlineAfterEmptyline();
            Namespace.genericRenderer(content)(builder);
        });
        builder
            .unindent()
            .addThenNewline("}");
    };
    Namespace.prototype.verify = function (builder) {
    };
    return Namespace;
}(renderer_1.NamedRenderer));
exports.Namespace = Namespace;
