import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
import { Type } from "./type";
export interface IVariable {
    readonly assignment?: string;
    readonly type: Type.Required;
}
export declare class Variable extends NamedRenderer {
    private readonly props;
    private readonly exported;
    private readonly mutable;
    static newExported(props: IVariable): Variable;
    static newImmutable(props: IVariable): Variable;
    static newMutable(props: IVariable): Variable;
    private constructor();
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
