"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Variable = (function (_super) {
    __extends(Variable, _super);
    function Variable(props, exported, mutable) {
        var _this = _super.call(this) || this;
        _this.props = props;
        _this.exported = exported;
        _this.mutable = mutable;
        return _this;
    }
    Variable.newExported = function (props) {
        return new Variable(props, true, false);
    };
    Variable.newImmutable = function (props) {
        return new Variable(props, false, false);
    };
    Variable.newMutable = function (props) {
        return new Variable(props, false, true);
    };
    Variable.prototype.render = function (builder) {
        if (this.exported) {
            builder.add("export ");
        }
        if (this.mutable) {
            builder.add("let ");
        }
        else {
            builder.add("const ");
        }
        this.props.type.run(builder);
        if (this.props.assignment !== undefined) {
            builder.addThenNewline(" = " + this.props.assignment + ";");
        }
        else {
            builder.addThenNewline(";");
        }
    };
    Variable.prototype.verify = function (builder) {
    };
    return Variable;
}(renderer_1.NamedRenderer));
exports.Variable = Variable;
