import { Builder } from "./builder";
import { NamedRenderer } from "./renderer";
import { Type } from "./type";
export interface IAlias {
    readonly name: string;
    readonly templates?: string[];
    readonly type: Type.Anonymous;
}
export declare class Alias extends NamedRenderer {
    private readonly props;
    private readonly exported;
    static newExported(props: IAlias): Alias;
    static newInternal(props: IAlias): Alias;
    private constructor();
    protected render(builder: Builder): void;
    protected verify(builder: Builder): void;
}
