"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
var Alias = (function (_super) {
    __extends(Alias, _super);
    function Alias(props, exported) {
        var _this = _super.call(this) || this;
        _this.props = props;
        _this.exported = exported;
        return _this;
    }
    Alias.newExported = function (props) {
        return new Alias(props, true);
    };
    Alias.newInternal = function (props) {
        return new Alias(props, false);
    };
    Alias.prototype.render = function (builder) {
        builder.withIdentifiers(this.props.name);
        if (this.exported) {
            builder.add("export ");
        }
        builder.add("type " + this.props.name);
        if (this.props.templates !== undefined) {
            builder.add("<" + this.props.templates.join(", ") + ">");
        }
        builder.add(" = ");
        this.props.type.run(builder);
        builder.addThenNewline(";");
    };
    Alias.prototype.verify = function (builder) {
    };
    return Alias;
}(renderer_1.NamedRenderer));
exports.Alias = Alias;
