"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var renderer_1 = require("./renderer");
exports.startTemplate = "/* BESPOKE START <<@0>> */";
exports.endTemplate = "/* BESPOKE END <<@0>> */";
var Bespoke = (function (_super) {
    __extends(Bespoke, _super);
    function Bespoke(props) {
        var _this = _super.call(this) || this;
        _this.props = props;
        return _this;
    }
    Bespoke["new"] = function (props) {
        return new Bespoke(props);
    };
    Bespoke.prototype.render = function (builder) {
        builder.withBespokes(this.props.name);
        builder
            .addThenNewline(exports.startTemplate.replace("@0", this.props.name))
            .addThenNewline(exports.endTemplate.replace("@0", this.props.name));
    };
    Bespoke.prototype.verify = function (builder) {
    };
    return Bespoke;
}(renderer_1.NamedRenderer));
exports.Bespoke = Bespoke;
