import { Module } from "./module";
import { Type } from "./type";
export interface IJest {
    destination: string;
    tests: string[];
}
export declare function Jest(props: IJest): Module;
export declare enum ERelayType {
    FRAGMENT = "createFragmentContainer",
    PAGINATION = "createPaginationContainer",
    REFETCH = "createRefetchContainer"
}
export interface IReact {
    destination: string;
    name: string;
    props?: Array<Type.Optional | Type.Required>;
    relayMutation?: boolean;
    relayType?: ERelayType;
    state?: Array<Type.Optional | Type.Required>;
}
export declare function React(props: IReact): Module;
