import { Builder } from "./builder";
export declare type AnonymousRenderer = (builder: Builder) => void;
export declare abstract class NamedRenderer {
    protected static genericRenderer(renderer: TRenderer): AnonymousRenderer;
    print(builder?: Builder): string;
    run(builder: Builder): void;
    protected abstract render(builder: Builder): void;
    protected abstract verify(builder: Builder): void;
}
export declare type TRenderer = AnonymousRenderer | NamedRenderer;
